/*
TSC - A program to convert Truevision Targa (TGA) and bitmap (BMP) images to data for use in TI assembly or C programming
Copyright (C) 2007  Peter Fernandes

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef _WIN32
#define IMAGE_VIEWER "paint"
#else
	#ifdef __APPLE__
	#define IMAGE_VIEWER "preview"
	#else
		#ifdef macintosh
		#define IMAGE_VIEWER "simpletext"
		#else
		#define IMAGE_VIEWER "kview"
		#endif
	#endif
#endif


#define move_to_val(val,x,amt) (x>val?(x-amt>val?x-amt:val):(x+amt<val?x+amt:val))


typedef struct {
	unsigned shades:4;
	unsigned verbosity:1;
	unsigned help:1;
	unsigned preview:1;
	unsigned interlaced:1;
	int output;
	int brightness; //-100 for completely dark to 100 for completely bright
	int contrast; //0 for no contrast to 100 for max contrast
} options;


typedef struct {
	int height;
	int width;
	unsigned char *data;
} IMAGE;



enum {WHITE,DARK_WHITE,LIGHT_LIGHT,LIGHT,LIGHT_DARK,DARK,LIGHT_BLACK,BLACK};
enum {OUT_BIN=1,OUT_HEX=2};
enum {LANG_C=4,LANG_ASM=8,LANG_RAW=16,ARRAY_PROD=32,DISP_HORIZ=64,OUT_SINGLE=128};

extern void clean_up(void);
extern int write_preview(char *prgm, unsigned char *buffer, int height, int width, int shades);
extern char *basename(char *name);
extern int load_image(IMAGE *img, FILE *src, options *opts);



